#ifndef SRM_INFO_H_
#define SRM_INFO_H_

#include "srm_url.h"
#include "../../misc/condition.h"

/**
 * Info about a particular entry in the SRM info file
 */
class SRMFileInfo {
 public:
  std::string host;
  int port;
  std::string protocol;
  enum SRM_URL::SRM_URL_VERSION version;
  bool operator==(SRM_URL srm_url);
  std::string versionString() const;
};

/**
 * Represents SRM info stored in file. A combination of host and SRM
 * version make a unique entry.
 */
class SRMInfo {
 public:
  SRMInfo(std::string dir);
  bool getSRMFileInfo(SRMFileInfo& srm_file_info);
  void putSRMFileInfo(const SRMFileInfo& srm_file_info);
 private:
  std::string srm_info_filename;
  static LockSimple filelock;
};

#endif /*SRM_INFO_H_*/
